// original source http://mgeshaderlibrary.wikispaces.com/SSNM
// Author: peachykeen
// Title: SSNM v2
// converted by Ren712
// makeshift.fx
//


//---------------------------------------------------------------------
// Settings
//---------------------------------------------------------------------
float2 rcpres = float2(0.0015,0.0015);
texture sTex0 :TEX0;

//---------------------------------------------------------------------
// Include some common stuff
//---------------------------------------------------------------------
#include "mta-helper.fx"


//---------------------------------------------------------------------
// Sampler for the main texture
//---------------------------------------------------------------------
sampler Sampler0 = sampler_state
{
    Texture = (sTex0);
	minfilter = linear; 
	magfilter = linear; 
	mipfilter = linear; 
	addressu = clamp; 
	addressv = clamp;
};


//---------------------------------------------------------------------
// Structure of data sent to the pixel shader ( from the vertex shader )
//---------------------------------------------------------------------
struct PSInput
{
  float4 Position : POSITION0;
  float4 Diffuse : COLOR0;
  float2 TexCoord : TEXCOORD0;
};


//------------------------------------------------------------------------------------------
// PixelShaderFunction
//  1. Read from PS structure
//  2. Process
//  3. Return pixel color
//------------------------------------------------------------------------------------------
float4 PixelShaderFunction(PSInput PS) : COLOR0
{
	float4 nShift = 0.5;
	float3x3 depth;
	depth[1][1] = tex2D(Sampler0, PS.TexCoord).r;///1000;
	depth[0][1] = tex2D(Sampler0, float2(PS.TexCoord.x, PS.TexCoord.y-rcpres.y)).r;///1000;
	nShift.r = (depth[1][1] - depth[0][1]) + 0.5;
	depth[0][0] = tex2D(Sampler0, float2(PS.TexCoord.x-rcpres.x, PS.TexCoord.y)).r;///1000;
	nShift.b = (depth[1][1] - depth[0][0]) + 0.5;
	return nShift;
}


//------------------------------------------------------------------------------------------
// Techniques
//------------------------------------------------------------------------------------------
technique tec0
{
    pass P0
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}

// Fallback
technique fallback
{
    pass P0
    {
        // Just draw normally
    }
}
